config/routes.rb
Rails.application.routes.draw do
  devise_for :admins, path: 'admins', skip: [:registrations]
  devise_for :users, path: 'users'

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root to: 'home#home'

  scope :admin do
    devise_scope :admin do
      authenticated :admin do
        root 'admin/home#home', as: :admin_root
      end

      unauthenticated :admin do
        root 'devise/sessions#new', as: :unauthenticated_admin_root
      end
    end
  end

  namespace :admin do
    resources :questions, only: %i[index show edit update destroy]
  end

  resources :questions do
    resources :answers, shallow: true
  end
end

app/models/admin.rb
class Admin < ApplicationRecord
  enum role: { super: 0, manager: 1, editor: 2 }

  validates :role, presence: true

  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  # :registerable
  devise :database_authenticatable,
         :recoverable,
         :rememberable,
         :trackable,
         :validatable
end

app/models/answer.rb
# frozen_string_literal: true

class Answer < ApplicationRecord
  belongs_to :question
  belongs_to :user

  validates :body, presence: true, length: { minimum: 20, maximum: 1000 }
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/question.rb
# frozen_string_literal: true

class Question < ApplicationRecord
  belongs_to :user
  has_many :answers, dependent: :restrict_with_error

  validates :title, presence: true
end

app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  has_many :questions, dependent: :restrict_with_error
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable,
         :registerable,
         :recoverable,
         :rememberable,
         :trackable,
         :confirmable,
         :validatable
end

app/controllers/admin/base_controller.rb
# frozen_string_literal: true

class Admin::BaseController < ApplicationController
  before_action :authenticate_admin!

  private

  def base_layout
    'admin'
  end
end

app/controllers/admin/home_controller.rb
# frozen_string_literal: true

class Admin::HomeController < Admin::BaseController
  skip_after_action :verify_authorized

  def home; end
end

app/controllers/admin/questions_controller.rb
# frozen_string_literal: true

class Admin::QuestionsController < Admin::BaseController
  before_action :find_question, only: %i[show edit update destroy]
  skip_after_action :verify_authorized, only: %i[index show]

  def index
    @questions = Question.all
  end

  def show; end

  def edit
    authorize @question
  end

  def update
    authorize @question
    respond_to do |format|
      if @question.update(question_params)
        flash[:notice] = t('.success')
        format.html { redirect_to [:admin, @question] }
      else
        format.html { render :edit }
      end
      format.js { render 'admin/questions/update' }
    end
  end

  def destroy
    authorize @question
    @question.destroy
    flash[:notice] = t('.success')
    respond_to do |format|
      format.html do
        redirect_to admin_questions_path
      end

      format.js { render 'admin/questions/destroy' }
    end
  end

  private

  def find_question
    @question = Question.find(params[:id])
  end

  def question_params
    params.require(:question).permit(:title, :body)
  end
end

app/controllers/answers_controller.rb
# frozen_string_literal: true

class AnswersController < ApplicationController
  skip_after_action :verify_authorized, only: %i[index]
  before_action :find_question, only: %i[index create]

  # for the case of page refresh after unsuccessful form submit
  def index
    redirect_to @question
  end

  def create
    @answer = @question.answers.new(answer_params)
    authorize @answer
    @answer.user = current_user
    if @answer.save
      flash[:notice] = t('.success')
      redirect_to @question
    else
      render 'questions/show'
    end
  end

  private

  def answer_params
    params.require(:answer).permit(:body)
  end

  def find_question
    @question = Question.find(params[:question_id])
  end
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  include Pundit

  rescue_from Pundit::NotAuthorizedError, with: :user_not_authorized

  layout :choose_layout

  after_action :verify_authorized, unless: :devise_controller?

  private

  def choose_layout
    return 'devise' if devise_controller?

    base_layout
  end

  def pundit_user
    current_user || current_admin
  end

  def user_not_authorized(exception)
    policy_name = exception.policy.class.to_s.underscore

    flash[:error] = t("#{policy_name}.#{exception.query}", scope: "pundit", default: :default)
    redirect_to(request.referrer || root_path)
  end

  def base_layout
    'application'
  end
end

app/controllers/base_controller.rb
# frozen_string_literal: true

class BaseController < ApplicationController
  before_action :authenticate_user!
end

app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < BaseController
  skip_before_action :authenticate_user!
  skip_after_action :verify_authorized

  def home; end
end

app/controllers/questions_controller.rb
# frozen_string_literal: true

class QuestionsController < BaseController
  skip_before_action :authenticate_user!, only: %i[index show]
  skip_after_action :verify_authorized, only: %i[index show]

  before_action :find_question, only: %i[show edit update destroy]

  def index
    @questions = Question.all
  end

  def show
    @answer = Answer.new
  end

  def new
    @question = Question.new
    authorize @question
  end

  def create
    @question = current_user.questions.new(question_params)
    authorize @question
    if @question.save
      flash[:notice] = t('.success')
      redirect_to @question
    else
      render :new
    end
  end

  def edit
    authorize @question
  end

  def update
    authorize @question
    respond_to do |format|
      if @question.update(question_params)
        flash[:notice] = t('.success')
        format.html { redirect_to @question }
      else
        format.html { render :edit }
      end
      format.js
    end
  end

  def destroy
    authorize @question
    @question.destroy
    flash[:notice] = t('.success')
    respond_to do |format|
      format.html do
        redirect_to questions_path
      end

      format.js
    end
  end

  private

  def question_params
    params.require(:question).permit(:title, :body)
  end

  def find_question
    @question = Question.find(params[:id])
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/bootstrap_flash_helper.rb
# frozen_string_literal: true

module BootstrapFlashHelper
  ALERT_TYPES = %i[success info warning danger].freeze unless const_defined?(:ALERT_TYPES)

  def bootstrap_flash(options = {})
    flash_messages = []
    flash.each do |type, message|
      # Skip empty messages, e.g. for devise messages set to nothing in a locale file.
      next if message.blank?

      type = define_type(type)
      next unless ALERT_TYPES.include?(type)

      tag_options = tag_options(type, options).merge(options)
      flash_messages += flash_messages(message, tag_options)
    end

    flash_messages.join("\n").html_safe
  end

  private

  def flash_messages(message, tag_options)
    flash_messages = []

    Array(message).each do |msg|
      text = content_tag(:div, close_button + msg, tag_options)
      flash_messages << text if msg
    end

    flash_messages
  end

  def define_type(type)
    type = type.to_sym
    return :success if type == :notice
    return :danger  if type == :alert
    return :danger  if type == :error

    type
  end

  def tag_options(type, options)
    tag_class = options.extract!(:class)[:class]

    {
      class: "alert alert-#{type} #{tag_class}",
      role: "alert"
    }
  end

  def close_button
    button_options = {
      type: "button",
      class: "close",
      data: { dismiss: "alert" },
      aria: { label: "Close"}
    }

    content_tag(:button, button_options) do
      content_tag(:span, class: 'mg-l-10', aria: { hidden: true }) do
        raw('&times;')
      end
    end
  end
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/questions_helper.rb
module QuestionsHelper
end

app/views/admin/home/home.html.slim
.pd-x-20.pd-sm-x-30.pd-t-20.pd-sm-t-30
  h4.tx-gray-800.mg-b-5 = t('.title')
  p.mg-b-0 = t('.subtitle')

/ h1 Admin Questions Index
.br-pagebody
  .errors
  .br-section-wrapper
    | Here Admin Home Page

app/views/answers/_answer.html.slim
hr
.row.tx-gray-800
  .col-md
    p = answer.body
.row.justify-content-between.mg-t-30
  .col-sm-2
  .col-sm-10.col-md-6.col-xl-4
    .card.bg-gray-200.bd-0
      .card-body
        .author
          = "#{t('.author')}: "
          = link_to answer.user.email, '', class: 'tx-inverse'
        .question_id
          = "#{t('.answer_id')}: "
          span.tx-gray-800 = answer.id

app/views/answers/_form.html.slim
h6.tx-gray-800.tx-uppercase.tx-bold.tx-14.mg-b-10.mg-t-80
  = t('.your_answer')
p.mg-b-25.mg-lg-b-30
  = t('.put_your_answer')

.errors-answer
  - if @answer&.errors
    = render 'shared/errors', resource: @answer
= form_with(model: [@question, @answer], local: true) do |f|
  .form-group
    = f.label :body
    = f.text_area :body, class: 'form-control'
  = f.submit t('.submit'), class: 'btn btn-info'

app/views/home/home.html.slim
.pd-x-20.pd-sm-x-30.pd-t-20.pd-sm-t-30
  h4.tx-gray-800.mg-b-5 = t('.title')
  p.mg-b-0 = t('.subtitle')

.br-pagebody
  .errors
  .br-section-wrapper
    | Here Home Page

app/views/layouts/admin/_head_panel.html.slim
/! ########## START: HEAD PANEL ##########
.br-header#header
  .br-header-left
    .navicon-left.hidden-md-down
      a#btnLeftMenu href=""
        i.icon.ion-navicon-round
    .navicon-left.hidden-lg-up
      a#btnLeftMenuMobile href=""
        i.icon.ion-navicon-round
  /! br-header-left
  .br-header-right
    nav.nav
      = render 'layouts/admin/head_panel/profile_menu'
  /! br-header-right
/! br-header
/! ########## END: HEAD PANEL ##########

app/views/layouts/admin/_left_panel.html.slim
/! ########## START: LEFT PANEL ##########
.br-logo
  = link_to admin_root_path do
    span
      | [
    | q&a admin
    span
      | ]
.br-sideleft.overflow-y-auto
  label.sidebar-label.pd-x-15.mg-t-20 = t('.navigation')
  .br-sideleft-menu
    = link_to admin_root_path, class: 'br-menu-link' do
      .br-menu-item
        i.menu-item-icon.icon.ion-ios-home-outline.tx-22
        span.menu-item-label = t('.home')
      /! menu-item
    /! br-menu-link
    = link_to admin_questions_path, class: 'br-menu-link' do
      .br-menu-item
        i.menu-item-icon.icon.ion-ios-help-outline.tx-22
        span.menu-item-label = t('.questions')
      /! menu-item
    /! br-menu-link

  br
  /! br-sideleft
/! ########## END: LEFT PANEL ##########

app/views/layouts/admin/head_panel/_profile_menu.html.slim
.dropdown
  a.nav-link.nav-link-profile.d-flex data-toggle="dropdown" href=""
    span.logged-name.hidden-md-down.align-self-center.mg-r-20 = current_admin.email
    i.fas.fa-user-circle.tx-40.align-self-center
  .dropdown-menu.dropdown-menu-header.wd-200
    ul.list-unstyled.user-profile-nav
      li
        = link_to destroy_admin_session_path, method: :delete do
          i.icon.ion-power
          = t('devise.shared.logout')

app/views/layouts/head_panel/_profile_menu.html.slim
- if current_user
  .dropdown
    a.nav-link.nav-link-profile.d-flex data-toggle="dropdown" href=""
      span.logged-name.hidden-md-down.align-self-center.mg-r-20 = current_user.email
      i.fas.fa-user-circle.tx-40.align-self-center
    .dropdown-menu.dropdown-menu-header.wd-200
      ul.list-unstyled.user-profile-nav
        li
          = link_to destroy_user_session_path, method: :delete do
            i.icon.ion-power
            = t('devise.shared.logout')
- else
  .nav-item
    = link_to new_user_session_path, class: 'nav-link' do
      .d-flex
        span.align-self-center.mg-r-10 = t('devise.shared.login')
  .nav-item
    = link_to new_user_registration_path, class: 'nav-link' do
      .d-flex
        span.align-self-center.mg-r-10 = t('devise.shared.signup')

app/views/layouts/shared/_head.html.slim
title QA
= csrf_meta_tags
= csp_meta_tag
= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload'
= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload'

app/views/questions/_form.html.slim
= form_with model: @question, local: true do |f|
  .form-group
    = f.label :title
    = f.text_field :title,
      class: 'form-control'

  .form-group
    = f.label :body
    = f.text_area :body,
      class: 'form-control'
  = f.submit t('.submit'), class: 'btn btn-info btn-block'

app/views/questions/_inline_form.html.slim
.form-inline-container[hidden='true']
  - data = { path: '/questions/' }
  - options = { method: :patch, class: 'inline-form form-template form-inline', data: data }
  = form_with(url: '', scope: 'question', **options) do |f|
    .form-group
      = f.text_field :title, class: 'form-control-sm'
    = f.submit t('.submit'), class: 'btn btn-info btn-sm mg-l-2'
    button.close-form.btn.btn-secondary.btn-sm.mg-l-2 = t('.close')

app/views/questions/_question.html.slim
tr[id="question-#{question.id}-trow"]
  td.valign-middle[id="question-#{question.id}-container"]
    .question-title = link_to question.title, question, class: 'tx-gray-600'
  td.valign-middle = question.user.email
  td.valign-middle.tx-center
    - if policy(question).edit?
      = link_to edit_question_path(question),
        data: { id: question.id },
        class: "edit-question-link btn btn-icon btn-outline-warning" do
        div
          i.far.fa-edit.tx-18
    - if policy(question).destroy?
      - confirmation = t('shared.confirm_destroy',
        resource: question.class.to_s.downcase,
        attribute: 'title',
        value: question.title)
      = link_to question_path(question),
        method: :delete,
        remote: true,
        data: { confirm: confirmation },
        class: "btn btn-icon btn-outline-danger mg-l-3" do
        div
          i.far.fa-trash-alt.tx-18

app/views/questions/destroy.js.erb
var question = document.getElementById("question-<%= @question.id %>-trow");
var flashContainer = document.querySelector('.flash');
flashContainer.innerHTML = '<%= bootstrap_flash %>';
<% flash.discard %>
question.remove();

app/views/questions/edit.html.slim
.pd-x-20.pd-sm-x-30.pd-t-20.pd-sm-t-30
  h4.tx-gray-900.mg-b-5
    = t('.title')
  p.mg-b-0
    = "#{t('.asked')}: "
    span.tx-gray-700 = I18n.l(@question.created_at, format: :long)
  p.mg-b-0
    = "#{t('.question_id')}: "
    = link_to @question.id, @question, class: 'tx-gray-700'

.br-pagebody
  .errors
    - if @question.errors
      = render 'shared/errors', resource: @question
  .br-section-wrapper
    = render 'form'

app/views/questions/index.html.slim
.pd-x-20.pd-sm-x-30.pd-t-20.pd-sm-t-30
  h4.tx-gray-800.mg-b-5 = t('.title')
  p.mg-b-0 = t('.subtitle')

.br-pagebody
  .errors
  .br-section-wrapper
    .row
      .col
        - if policy(Question).new?
          = link_to t('shared.new'),
            new_question_path,
            class: 'btn btn-outline-info float-right'
    .row.mg-t-40
      .col
        .bd.bd-gray-300.rounded.table-responsive.tx-15
          table.table.mg-b-0
            thead
              tr
                th = t('.question_title')
                th = t('.user')
                th.tx-center = t('.actions')
            tbody
              = render @questions

= render 'inline_form'

app/views/questions/new.html.slim
.pd-x-20.pd-sm-x-30.pd-t-20.pd-sm-t-30
  h4.tx-gray-900.mg-b-5
    = t('.title')
  p.mg-b-0
    = t('.subtitle')

.br-pagebody
  .errors
    - if @question.errors
      = render 'shared/errors', resource: @question
  .br-section-wrapper
    = render 'form'

app/views/questions/show.html.slim
.pd-x-20.pd-sm-x-30.pd-t-20.pd-sm-t-30
  h4.tx-gray-900.mg-b-5 = @question.title
  - date = I18n.l(@question.created_at, format: :long)
  p.mg-b-0
    = "#{t('.asked')}: "
    span.tx-gray-700 = date
.br-pagebody
  .errors
  .br-section-wrapper
    .row.tx-gray-800
      .col-md
        p = @question.body
    .row.justify-content-between.mg-t-30
      .col-sm-2
        - if policy(@question).edit?
          = link_to t('shared.edit'),
            edit_question_path(@question),
            class: 'tx-info'
        - if policy(@question).destroy?
          - confirmation = t('shared.confirm_destroy',
            resource: @question.class.to_s.downcase,
            attribute: 'title',
            value: @question.title)
          = link_to t('shared.destroy'),
            question_path(@question),
            method: :delete,
            data: { confirm: confirmation },
            class: 'tx-info mg-l-15'
      .col-sm-10.col-md-6.col-xl-4
        .card.bg-gray-200.bd-0
          .card-body
            .author
              = "#{t('.author')}: "
              = link_to @question.user.email, '', class: 'tx-inverse'
            .question_id
              = "#{t('.question_id')}: "
              span.tx-gray-800 = @question.id
    - if @question.answers.any?
      - @answers = @question.answers.reload
      .row.mg-b-40[class="question-#{@question.id}-answers"]
        .col
          h6.tx-gray-800.tx-uppercase.tx-bold.tx-14.mg-b-10.mg-t-80
            = t('.answers')
          p.mg-b-25.mg-lg-b-30
            = t('.answered', count: @answers.size)
          = render @answers
    - if policy(Answer).new?
      .row.mg-t-20[class="question-#{@question.id}-new-answer"]
        .col
          = render 'answers/form'

app/views/questions/update.js.erb
var id = '<%= @question.id %>';
var questionContainer = document.querySelector('#question-' + id + '-container');
var form = questionContainer.querySelector('.inline-form');
var errorsContainer = document.querySelector('.errors');

<% if @question.errors.any? %>
  errorsContainer.innerHTML = '<%= j render("shared/errors", resource: @question) %>';
<% else %>
  var questionTitleDiv = document.createElement('div');
  var questionTitle = document.createElement('a')
  questionTitleDiv.classList.add('question-title');
  questionTitle.classList.add('tx-gray-600');
  questionTitle.setAttribute('href', '/questions/' + <%= @question.id %>);
  questionTitle.textContent = '<%= @question.reload.title %>';
  questionContainer.removeChild(form);
  questionTitleDiv.append(questionTitle);
  questionContainer.append(questionTitleDiv);
  errorsContainer.innerHTML = '';

  var flashContainer = document.querySelector('.flash');
  flashContainer.innerHTML = '<%= bootstrap_flash %>';
  <% flash.discard %>
<% end %>

app/views/shared/_errors.html.slim
- if resource.errors.any?
  #error_explanation
    .alert.alert-danger.alert-bordered.pd-y-20[role="alert"]
      button.close[type="button" data-dismiss="alert" aria-label="Close"]
        span.mg-l-10[aria-hidden="true"]
          | &times;
      .d-flex.align-items-center.justify-content-start
        div
          h5.mg-b-2.tx-danger
            = I18n.t("errors.messages.not_saved",
              count: resource.errors.count,
              resource: resource.class.model_name.human.downcase)
          - resource.errors.full_messages.each do |message|
            p.mg-b-0.tx-gray
              = message

app/views/users/shared/_error_messages.html.slim
- if resource.errors.any?
  #error_explanation
    .alert.alert-danger.alert-bordered.pd-y-20[role="alert"]
      button.close[type="button" data-dismiss="alert" aria-label="Close"]
        span.mg-l-10[aria-hidden="true"]
          | &times;
      .d-flex.align-items-center.justify-content-start
        div
          h5.mg-b-2.tx-danger
            = I18n.t("errors.messages.not_processing",
              count: resource.errors.count,
              resource: resource.class.model_name.human.downcase)
          - resource.errors.full_messages.each do |message|
            p.mg-b-0.tx-gray
              = message

app/views/users/shared/_links.html.slim
- if controller_name != 'sessions'
  = link_to t('.sign_in'), new_session_path(resource_name), class: 'tx-info tx-12 d-block mg-t-10'

- if devise_mapping.registerable? && controller_name != 'registrations'
  = link_to t('.sign_up'), new_registration_path(resource_name), class: 'tx-info tx-12 d-block mg-t-10'

- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations'
  = link_to t('.forgot'), new_password_path(resource_name), class: 'tx-info tx-12 d-block mg-t-10'

- if devise_mapping.confirmable? && controller_name != 'confirmations'
  = link_to t('.didnot_recieve'), new_confirmation_path(resource_name), class: 'tx-info tx-12 d-block mg-t-10'

- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks'
  = link_to t('.unlock'), new_unlock_path(resource_name), class: 'tx-info tx-12 d-block mg-t-10'

- if devise_mapping.omniauthable?
  - resource_class.omniauth_providers.each do |provider|
    = link_to "#{t('.sign_in_with')} #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider), class: 'tx-info tx-12 d-block mg-t-10'